final class Tree {
	Node root;

	//@ public inline resource tree_perm(Node current) = tree_perm_except(current, null);

	//@ requires [read]tree_perm(current);
	//@ public pure inline bag<int> to_bag(Node current) = to_bag_except(current, null);

	//@ requires [read]tree_perm(current);
	//@ public pure inline boolean sorted(Node current) = sorted_except(current, null);

	//@ requires [read]tree_perm(node);
	//@ public pure inline boolean get_color(Node node) = get_color(node, null);

	//@ requires [read]tree_perm(current);
	//@ public pure inline boolean no_db_red(Node current) = no_db_red_except(current, null);

	//@ requires [read]tree_perm(current);
	//@ public pure inline boolean db_red_at_top(Node current) = db_red_at_top_except(current, null);


	//@ public resource tree_perm_except(Node current, Node node) = current != null ==> (current != node ==> Perm(current.key, 1) ** Perm(current.color, 1) ** Perm(current.dblack, 1) ** Perm(current.left, 1) ** Perm(current.right, 1) ** tree_perm_except(current.left, node) ** tree_perm_except(current.right, node));

	//@ requires [read]tree_perm_except(current, node);
	//@ public pure boolean in_tree(Node current, Node node) = current != null ? node != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in (in_tree(current.left, node) || in_tree(current.right, node)) : true : false;

	//@ requires [read]tree_perm_except(current, node);
	//@ requires [read]tree_perm(node);
	//@ public pure boolean valid(Node current, Node node) = current != null ? node != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in (((current.left == node ==> !get_color(current, node) || !get_color(node)) && valid(current.left, node) && !in_tree(current.right, node) && smaller(to_bag(node), current.key)) || ((current.right == node ==> !get_color(current, node) || !get_color(node)) && valid(current.right, node) && !in_tree(current.left, node) && larger(to_bag(node), current.key))) : true : false;

	//@ requires [read]tree_perm_except(current, node);
	//@ public pure boolean no_db_red_except(Node current, Node node) = current != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in ((!get_color(current, node) || (!get_color(current.left, node) && !get_color(current.right, node))) && no_db_red_except(current.left, node) && no_db_red_except(current.right, node)) : true;

	//@ requires [read]tree_perm_except(current, node);
	//@ public pure boolean db_red_at_top_except(Node current, Node node) = current != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in (get_color(current, node) && ((get_color(current.left, node) && !get_color(current.right, node)) || (!get_color(current.left, node) && get_color(current.right, node))) && no_db_red_except(current.left, node) && no_db_red_except(current.right, node)) : true;

	//@ requires [read]tree_perm_except(current, node);
	//@ public pure bag<int> to_bag_except(Node current, Node node) = current != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in (to_bag_except(current.left, node) + bag<int> { current.key } + to_bag_except(current.right, node)) : bag<int> { };

	//@ public pure boolean smaller(bag<int> b, int max) = (\forall int i; (i \memberof b) != 0; i <= max);

	//@ public pure boolean larger(bag<int> b, int min) = (\forall int i; (i \memberof b) != 0; i >= min);
	//@ public pure boolean larger(bag<int> b1, bag<int> b2) = (\forall int i; (i \memberof b2) != 0; larger(b1, i));

	//@ static pure boolean subbag(bag<int> b1, bag<int> b2) = (\forall int i; (i \memberof b1) != 0; (i \memberof b2) != 0);

	//@ requires [read]tree_perm_except(current, node);
	//@ public pure boolean sorted_except(Node current, Node node) = current != null && current != node ? \unfolding [read]tree_perm_except(current, node) \in (smaller(to_bag_except(current.left, node), current.key) && larger(to_bag_except(current.right, node), current.key) && sorted_except(current.left, node) && sorted_except(current.right, node)) : true;

	//@ requires [read]tree_perm_except(node, exclusion);
	//@ public pure boolean get_color(Node node, Node exclusion) = node != null && node != exclusion ? \unfolding [read]tree_perm_except(node, exclusion) \in (node.color) : false;


	/*@
		requires node != null ** tree_perm(current) ** ([1/2]tree_perm(node)) ** sorted(current) ** sorted(node) ** no_db_red(current) ** no_db_red(node);
		requires B == to_bag(current);
		requires old_color == get_color(current);
		ensures node != null ** current != node ** tree_perm_except(current, node) ** !in_tree(current, node) ** ([1/2]tree_perm(node)) ** sorted_except(current, node) ** sorted(node) ** no_db_red_except(current, node) ** no_db_red(node);
		ensures B == to_bag_except(current, node);
		ensures old_color == get_color(current, node);
		public void prove_not_in_tree(Node current, Node node, bag<int> B, boolean old_color) {
			if (current == null) {
				fold tree_perm_except(current, node);
				return;
			}

			unfold tree_perm(current);
			unfold [1/2]tree_perm(node);
			assert current != node;
			fold [1/2]tree_perm(node);
			prove_not_in_tree(current.left, node, to_bag(current.left), get_color(current.left));
			prove_not_in_tree(current.right, node, to_bag(current.right), get_color(current.right));
			fold tree_perm_except(current, node);
		}
	@*/

	/*@
		requires node != null ** tree_perm_except(current, node) ** !in_tree(current, node) ** sorted_except(current, node) ** no_db_red_except(current, node);
		requires B == to_bag_except(current, node);
		requires old_color == get_color(current, node);
		ensures node != null ** tree_perm(current) ** sorted(current) ** no_db_red(current);
		ensures B == to_bag(current);
		ensures old_color == get_color(current);
		public void prove_safe_disregard(Node current, Node node, bag<int> B, boolean old_color) {
			if (current == null) {
				fold tree_perm(current);
				return;
			}

			unfold tree_perm_except(current, node);
			prove_safe_disregard(current.left, node, to_bag_except(current.left, node), get_color(current.left, node));
			prove_safe_disregard(current.right, node, to_bag_except(current.right, node), get_color(current.right, node));
			fold tree_perm(current);
		}
	@*/

	/*@
		requires node != null ** tree_perm_except(current, node) ** tree_perm(node) ** valid(current, node) ** sorted_except(current, node) ** sorted(node) ** no_db_red_except(current, node) ** no_db_red(node);
		requires B1 == to_bag_except(current, node) ** B2 == to_bag(node);
		requires current == node ==> old_color == get_color(node);
		requires current != node ==> old_color == get_color(current, node);
		ensures node != null ** tree_perm(current) ** sorted(current) ** no_db_red(current);
		ensures B1 + B2 == to_bag(current);
		ensures old_color == get_color(current);
		public void combine(Node current, Node node, bag<int> B1, bag<int> B2, boolean old_color) {
			if (current == null) {
				fold tree_perm(current);
				return;
			}

			if (current == node) {
				unfold tree_perm(node);
				fold tree_perm(current);
				return;
			}

			unfold tree_perm_except(current, node);
			if (valid(current.left, node) && !in_tree(current.right, node) && smaller(to_bag(node), current.key)) {
				if (current.left != node) {
					combine(current.left, node, to_bag_except(current.left, node), to_bag(node), get_color(current.left, node));
				} else {
					combine(current.left, node, to_bag_except(current.left, node), to_bag(node), get_color(node));
				}
				prove_safe_disregard(current.right, node, to_bag_except(current.right, node), get_color(current.right, node));
			} else {
				if (current.right != node) {
					combine(current.right, node, to_bag_except(current.right, node), to_bag(node), get_color(current.right, node));
				} else {
					combine(current.right, node, to_bag_except(current.right, node), to_bag(node), get_color(node));
				}
				prove_safe_disregard(current.left, node, to_bag_except(current.left, node), get_color(current.left, node));
			}

			fold tree_perm(current);
		}
	@*/


	//@ context Perm(root, 1) ** tree_perm(root) ** sorted(root) ** no_db_red(root);
	void insert(int key) {
		root = insertRec(root, key) /*@ with { B = to_bag(root); old_color = get_color(root); } @*/;
		//@ unfold tree_perm(root);
		root.color = false;
		//@ fold tree_perm(root);
	}

	//@ given bag<int> B;
	//@ given boolean old_color;
	//@ requires tree_perm(current) ** sorted(current) ** no_db_red(current);
	//@ requires B == to_bag(current);
	//@ requires old_color == get_color(current);
	//@ ensures \result != null ** tree_perm(\result) ** sorted(\result);
	//@ ensures no_db_red(\result) || db_red_at_top(\result);
	//@ ensures B + bag<int> { key } == to_bag(\result);
	//@ ensures old_color == get_color(\result) || \unfolding tree_perm(\result) \in (\result.color && !get_color(\result.left) && !get_color(\result.right));
	Node insertRec(Node current, int key) {
		if (current == null) {
			Node result = new Node(key);
			//@ fold tree_perm(result.left);
			//@ fold tree_perm(result.right);
			//@ fold tree_perm(result);
			return result;
		}

		//@ unfold tree_perm(current);
		if (key <= current.key) {
			current.left = insertRec(current.left, key) /*@ with { B = to_bag(current.left); old_color = get_color(current.left); } @*/;
		} else {
			current.right = insertRec(current.right, key) /*@ with { B = to_bag(current.right); old_color = get_color(current.right); } @*/;
		}

		if (current.color == false) {
			//@ unfold tree_perm(current.left);
			//@ unfold tree_perm(current.right);
			if ((current.left != null && current.left.color == true) && (current.right != null && current.right.color == true)) {
				//@ unfold tree_perm(current.left.left);
				//@ unfold tree_perm(current.left.right);
				//@ unfold tree_perm(current.right.left);
				//@ unfold tree_perm(current.right.right);
				if ((current.left.left != null && current.left.left.color == true)
						|| (current.left.right != null && current.left.right.color == true)
						|| (current.right.left != null && current.right.left.color == true)
						|| (current.right.right != null && current.right.right.color == true)) {
					current.color = true;
					current.left.color = false;
					current.right.color = false;
				}

				//@ fold tree_perm(current.left.left);
				//@ fold tree_perm(current.left.right);
				//@ fold tree_perm(current.right.left);
				//@ fold tree_perm(current.right.right);
				//@ fold tree_perm(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				return current;
			}

			if (current.left != null && current.left.color == true) {
				//@ unfold tree_perm(current.left.right);
				if (current.left.right != null && current.left.right.color == true) {
					//@ Node right_left = current.left.right.left;
					//@ fold tree_perm(current.left.right);
					//@ boolean right_color = get_color(current.left.right);
					//@ fold tree_perm(current.left);
					current.left = rotateLeft(current.left) /*@ with { B = to_bag(current.left); node_color = get_color(current.left); right_node_color = right_color; right_left_node = right_left; rcase = 1; } @*/;
					//@ unfold tree_perm(current.left);
					//@ unfold tree_perm(current.left.right);
				}
				//@ fold tree_perm(current.left.right);

				//@ unfold tree_perm(current.left.left);
				if (current.left.left != null && current.left.left.color == true) {
					//@ fold tree_perm(current.left.left);
					//@ Node left_right = current.left.right;
					//@ fold tree_perm(current.left);
					//@ boolean left_color = get_color(current.left);
					//@ fold tree_perm(current.right);
					//@ fold tree_perm(current);
					current = rotateRight(current) /*@ with { B = to_bag(current); node_color = get_color(current); left_node_color = left_color; left_right_node = left_right; rcase = 2; } @*/;
					return current;
				}
				//@ fold tree_perm(current.left.left);

				//@ fold tree_perm(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				return current;
			}

			if (current.right != null && current.right.color == true) {
				//@ unfold tree_perm(current.right.left);
				if (current.right.left != null && current.right.left.color == true) {
					//@ Node left_right = current.right.left.right;
					//@ fold tree_perm(current.right.left);
					//@ boolean left_color = get_color(current.right.left);
					//@ fold tree_perm(current.right);
					current.right = rotateRight(current.right) /*@ with { B = to_bag(current.right); node_color = get_color(current.right); left_node_color = left_color; left_right_node = left_right; rcase = 1; } @*/;
					//@ unfold tree_perm(current.right);
					//@ unfold tree_perm(current.right.left);
				}
				//@ fold tree_perm(current.right.left);

				//@ unfold tree_perm(current.right.right);
				if (current.right.right != null && current.right.right.color == true) {
					//@ fold tree_perm(current.right.right);
					//@ fold tree_perm(current.left);
					//@ Node right_left = current.right.left;
					//@ fold tree_perm(current.right);
					//@ boolean right_color = get_color(current.right);
					//@ fold tree_perm(current);
					current = rotateLeft(current) /*@ with { B = to_bag(current); node_color = get_color(current); right_node_color = right_color; right_left_node = right_left; rcase = 2; } @*/;
					return current;
				}
				//@ fold tree_perm(current.right.right);

				//@ fold tree_perm(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				return current;
			}

			//@ fold tree_perm(current.left);
			//@ fold tree_perm(current.right);
		}

		//@ fold tree_perm(current);
		return current;
	}

	//@ context Perm(root, 1) ** tree_perm(root) ** sorted(root) ** no_db_red(root);
	void deleteKey(int key) {
		if (root != null) {
			root = deleteRec(root, key) /*@ with { B = to_bag(root); old_color = get_color(root); } @*/;
		}
		if (root != null) {
			//@ unfold tree_perm(root);
			root.color = false;
			root.dblack = false;
			//@ fold tree_perm(root);
		}
	}

	//@ given bag<int> B;
	//@ given boolean old_color;
	//@ requires current != null ** tree_perm(current) ** sorted(current) ** no_db_red(current);
	//@ requires B == to_bag(current);
	//@ requires old_color == get_color(current);
	//@ ensures tree_perm(\result) ** sorted(\result) ** no_db_red(\result);
	//@ ensures (key \memberof B) == 0 ==> B == to_bag(\result);
	//@ ensures (key \memberof B) != 0 ==> B == to_bag(\result) + bag<int> { key };
	//@ ensures !old_color ==> !get_color(\result);
	Node deleteRec(Node current, int key) {
		//@ unfold tree_perm(current);
		if (key < current.key) {
			if (current.left == null) {
				//@ fold tree_perm(current);
				return current;
			}

			//@ bag<int> left_before = to_bag(current.left);
			current.left = deleteRec(current.left, key) /*@ with { B = left_before; old_color = get_color(current.left); } @*/;
			//@ bag<int> left_after = to_bag(current.left);
			//@ assert subbag(left_after, left_before);

			// double black
			//@ unfold tree_perm(current.left);
			if (current.right != null && (current.left == null || (current.left.color == false && current.left.dblack == true))) {
				if (current.left != null) {
					current.left.dblack = false;
				}

				//@ unfold tree_perm(current.right);
				if (current.right.color == true && current.right.left != null) {
					//@ fold tree_perm(current.left);
					//@ Node right_left = current.right.left;
					//@ fold tree_perm(current.right);
					//@ boolean right_color = get_color(current.right);
					//@ fold tree_perm(current);
					Node result = rotateLeft(current) /*@ with { B = to_bag(current); node_color = get_color(current); right_node_color = right_color; right_left_node = right_left; rcase = 3; } @*/;

					//@ unfold tree_perm(result);
					Node new_cur = result.left;

					//@ unfold tree_perm(new_cur);
					//@ unfold tree_perm(new_cur.right);
					//@ unfold tree_perm(new_cur.right.left);
					//@ unfold tree_perm(new_cur.right.right);
					if ((new_cur.right.left == null || new_cur.right.left.color == false) && (new_cur.right.right == null || new_cur.right.right.color == false)) {
						new_cur.right.color = true;
						new_cur.color = false;

						//@ fold tree_perm(new_cur.right.left);
						//@ fold tree_perm(new_cur.right.right);
						//@ fold tree_perm(new_cur.right);
						//@ fold tree_perm(new_cur);
						//@ fold tree_perm(result);
						return result;
					}

					if ((new_cur.right.left != null && new_cur.right.left.color == true) && (new_cur.right.right == null || new_cur.right.right.color == false)) {
						//@ Node new_cur_left_right = new_cur.right.left.right;
						//@ fold tree_perm(new_cur.right.left);
						//@ boolean new_cur_left_color = get_color(new_cur.right.left);
						//@ fold tree_perm(new_cur.right.right);
						//@ fold tree_perm(new_cur.right);
						new_cur.right = rotateRight(new_cur.right) /*@ with { B = to_bag(new_cur.right); node_color = get_color(new_cur.right); left_node_color = new_cur_left_color; left_right_node = new_cur_left_right; rcase = 3; } @*/;
						//@ unfold tree_perm(new_cur.right);
						//@ unfold tree_perm(new_cur.right.left);
						//@ unfold tree_perm(new_cur.right.right);
					}

					if (new_cur.right.right != null && new_cur.right.right.color == true) {
						new_cur.right.right.color = false;

						//@ fold tree_perm(new_cur.right.left);
						//@ fold tree_perm(new_cur.right.right);
						//@ Node new_cur_right_left = new_cur.right.left;
						//@ fold tree_perm(new_cur.right);
						//@ boolean new_cur_right_color = get_color(new_cur.right);
						//@ fold tree_perm(new_cur);
						result.left = rotateLeft(new_cur) /*@ with { B = to_bag(new_cur); node_color = get_color(new_cur); right_node_color = new_cur_right_color; right_left_node = new_cur_right_left; rcase = 4; } @*/;

						//@ fold tree_perm(result);
						return result;
					}

					//@ fold tree_perm(new_cur.right.left);
					//@ fold tree_perm(new_cur.right.right);
					//@ fold tree_perm(new_cur.right);
					//@ fold tree_perm(new_cur);
					//@ fold tree_perm(result);
					return result;
				}

				//@ unfold tree_perm(current.right.left);
				//@ unfold tree_perm(current.right.right);
				if (current.right.color == false && (current.right.left == null || current.right.left.color == false) && (current.right.right == null || current.right.right.color == false)) {
					current.right.color = true;
					if (current.color == true) {
						current.color = false;
					} else {
						current.dblack = true;
					}

					//@ fold tree_perm(current.right.left);
					//@ fold tree_perm(current.right.right);
					//@ fold tree_perm(current.left);
					//@ fold tree_perm(current.right);
					//@ fold tree_perm(current);
					return current;
				}

				if ((current.right.left != null && current.right.left.color == true) && (current.right.right == null || current.right.right.color == false)) {
					//@ Node left_right = current.right.left.right;
					//@ fold tree_perm(current.right.left);
					//@ boolean left_color = get_color(current.right.left);
					//@ fold tree_perm(current.right.right);
					//@ fold tree_perm(current.right);
					current.right = rotateRight(current.right) /*@ with { B = to_bag(current.right); node_color = get_color(current.right); left_node_color = left_color; left_right_node = left_right; rcase = 3; } @*/;
					//@ unfold tree_perm(current.right);
					//@ unfold tree_perm(current.right.left);
					//@ unfold tree_perm(current.right.right);
				}

				if (current.right.right != null && current.right.right.color == true) {
					current.right.right.color = false;

					//@ fold tree_perm(current.right.left);
					//@ fold tree_perm(current.right.right);
					//@ fold tree_perm(current.left);
					//@ Node right_left = current.right.left;
					//@ fold tree_perm(current.right);
					//@ boolean right_color = get_color(current.right);
					//@ fold tree_perm(current);
					Node result = rotateLeft(current) /*@ with { B = to_bag(current); node_color = get_color(current); right_node_color = right_color; right_left_node = right_left; rcase = 4; } @*/;
					return result;
				}

				//@ fold tree_perm(current.right.left);
				//@ fold tree_perm(current.right.right);
				//@ fold tree_perm(current.right);
			}

			//@ fold tree_perm(current.left);
			//@ fold tree_perm(current);
			return current;
		}

		if (key > current.key) {
			if (current.right == null) {
				//@ fold tree_perm(current);
				return current;
			}

			//@ bag<int> right_before = to_bag(current.right);
			current.right = deleteRec(current.right, key) /*@ with { B = right_before; old_color = get_color(current.right); } @*/;
			//@ bag<int> right_after = to_bag(current.right);
			//@ assert subbag(right_after, right_before);

			// double black
			//@ unfold tree_perm(current.right);
			if (current.left != null && (current.right == null || (current.right.color == false && current.right.dblack == true))) {
				if (current.right != null) {
					current.right.dblack = false;
				}

				//@ unfold tree_perm(current.left);
				if (current.left.color == true && current.left.right != null) {
					//@ Node left_right = current.left.right;
					//@ fold tree_perm(current.left);
					//@ boolean left_color = get_color(current.left);
					//@ fold tree_perm(current.right);
					//@ fold tree_perm(current);
					Node result = rotateRight(current) /*@ with { B = to_bag(current); node_color = get_color(current); left_node_color = left_color; left_right_node = left_right; rcase = 3; } @*/;

					//@ unfold tree_perm(result);
					Node new_cur = result.right;

					//@ unfold tree_perm(new_cur);
					//@ unfold tree_perm(new_cur.left);
					//@ unfold tree_perm(new_cur.left.left);
					//@ unfold tree_perm(new_cur.left.right);
					if ((new_cur.left.left == null || new_cur.left.left.color == false) && (new_cur.left.right == null || new_cur.left.right.color == false)) {
						new_cur.left.color = true;
						new_cur.color = false;

						//@ fold tree_perm(new_cur.left.left);
						//@ fold tree_perm(new_cur.left.right);
						//@ fold tree_perm(new_cur.left);
						//@ fold tree_perm(new_cur);
						//@ fold tree_perm(result);
						return result;
					}

					if ((new_cur.left.left == null || new_cur.left.left.color == false) && (new_cur.left.right != null && new_cur.left.right.color == true)) {
						//@ fold tree_perm(new_cur.left.left);
						//@ Node new_cur_right_left = new_cur.left.right.left;
						//@ fold tree_perm(new_cur.left.right);
						//@ boolean new_cur_right_color = get_color(new_cur.left.right);
						//@ fold tree_perm(new_cur.left);
						new_cur.left = rotateLeft(new_cur.left) /*@ with { B = to_bag(new_cur.left); node_color = get_color(new_cur.left); right_node_color = new_cur_right_color; right_left_node = new_cur_right_left; rcase = 3; } @*/;
						//@ unfold tree_perm(new_cur.left);
						//@ unfold tree_perm(new_cur.left.left);
						//@ unfold tree_perm(new_cur.left.right);
					}

					if (new_cur.left.left != null && new_cur.left.left.color == true) {
						new_cur.left.left.color = false;

						//@ fold tree_perm(new_cur.left.left);
						//@ fold tree_perm(new_cur.left.right);
						//@ Node new_cur_left_right = new_cur.left.right;
						//@ fold tree_perm(new_cur.left);
						//@ boolean new_cur_left_color = get_color(new_cur.left);
						//@ fold tree_perm(new_cur);
						result.right = rotateRight(new_cur) /*@ with { B = to_bag(new_cur); node_color = get_color(new_cur); left_node_color = new_cur_left_color; left_right_node = new_cur_left_right; rcase = 4; } @*/;

						//@ fold tree_perm(result);
						return result;
					}

					//@ fold tree_perm(new_cur.left.left);
					//@ fold tree_perm(new_cur.left.right);
					//@ fold tree_perm(new_cur.left);
					//@ fold tree_perm(new_cur);
					//@ fold tree_perm(result);
					return result;
				}

				//@ unfold tree_perm(current.left.left);
				//@ unfold tree_perm(current.left.right);
				if (current.left.color == false && (current.left.left == null || current.left.left.color == false) && (current.left.right == null || current.left.right.color == false)) {
					current.left.color = true;
					if (current.color == true) {
						current.color = false;
					} else {
						current.dblack = true;
					}

					//@ fold tree_perm(current.left.left);
					//@ fold tree_perm(current.left.right);
					//@ fold tree_perm(current.left);
					//@ fold tree_perm(current.right);
					//@ fold tree_perm(current);
					return current;
				}

				if ((current.left.left == null || current.left.left.color == false) && (current.left.right != null && current.left.right.color == true)) {
					//@ fold tree_perm(current.left.left);
					//@ Node right_left = current.left.right.left;
					//@ fold tree_perm(current.left.right);
					//@ boolean right_color = get_color(current.left.right);
					//@ fold tree_perm(current.left);
					current.left = rotateLeft(current.left) /*@ with { B = to_bag(current.left); node_color = get_color(current.left); right_node_color = right_color; right_left_node = right_left; rcase = 3; } @*/;
					//@ unfold tree_perm(current.left);
					//@ unfold tree_perm(current.left.left);
					//@ unfold tree_perm(current.left.right);
				}

				if (current.left.left != null && current.left.left.color == true) {
					current.left.left.color = false;

					//@ fold tree_perm(current.left.left);
					//@ fold tree_perm(current.left.right);
					//@ Node left_right = current.left.right;
					//@ fold tree_perm(current.left);
					//@ boolean left_color = get_color(current.left);
					//@ fold tree_perm(current.right);
					//@ fold tree_perm(current);
					Node result = rotateRight(current) /*@ with { B = to_bag(current); node_color = get_color(current); left_node_color = left_color; left_right_node = left_right; rcase = 4; } @*/;
					return result;
				}

				//@ fold tree_perm(current.left.left);
				//@ fold tree_perm(current.left.right);
				//@ fold tree_perm(current.left);
			}

			//@ fold tree_perm(current.right);
			//@ fold tree_perm(current);
			return current;
		}

		if (current.left == null) {
			Node result = current.right;

			//@ unfold tree_perm(result);
			if (current.color == false && result != null) {
				if (result.color == true) {
					result.color = false;
				} else {
					result.dblack = true;
				}
			}

			//@ fold tree_perm(result);
			return result;
		}

		if (current.right == null) {
			Node result = current.left;

			//@ unfold tree_perm(result);
			if (current.color == false && result != null) {
				if (result.color == true) {
					result.color = false;
				} else {
					result.dblack = true;
				}
			}

			//@ fold tree_perm(result);
			return result;
		}

		//@ bag<int> right_before = to_bag(current.right);
		Node successor = getMin(current.right) /*@ with { B = right_before; old_color = get_color(current.right); } @*/;
		//@ unfold tree_perm(successor);
		//@ bag<int> successor_key = bag<int> { successor.key };
		current.key = successor.key;
		//@ fold tree_perm(successor);
		/*@
			if (current.right != successor) {
				combine(current.right, successor, to_bag_except(current.right, successor), to_bag(successor), get_color(current.right, successor));
			} else {
				combine(current.right, successor, to_bag_except(current.right, successor), to_bag(successor), get_color(successor));
			}
		@*/
		current.right = deleteRec(current.right, current.key) /*@ with { B = right_before; old_color = get_color(current.right); } @*/;
		//@ bag<int> right_after = to_bag(current.right);
		//@ assert subbag(right_after, right_before);

		// double black
		//@ unfold tree_perm(current.right);
		if (current.right == null || (current.right.color == false && current.right.dblack == true)) {
			if (current.right != null) {
				current.right.dblack = false;
			}

			//@ unfold tree_perm(current.left);
			if (current.left.color == true && current.left.right != null) {
				//@ Node left_right = current.left.right;
				//@ fold tree_perm(current.left);
				//@ boolean left_color = get_color(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				Node result = rotateRight(current) /*@ with { B = to_bag(current); node_color = get_color(current); left_node_color = left_color; left_right_node = left_right; rcase = 3; } @*/;

				//@ unfold tree_perm(result);
				Node new_cur = result.right;

				//@ unfold tree_perm(new_cur);
				//@ unfold tree_perm(new_cur.left);
				//@ unfold tree_perm(new_cur.left.left);
				//@ unfold tree_perm(new_cur.left.right);
				if ((new_cur.left.left == null || new_cur.left.left.color == false) && (new_cur.left.right == null || new_cur.left.right.color == false)) {
					new_cur.left.color = true;
					new_cur.color = false;

					//@ fold tree_perm(new_cur.left.left);
					//@ fold tree_perm(new_cur.left.right);
					//@ fold tree_perm(new_cur.left);
					//@ fold tree_perm(new_cur);
					//@ fold tree_perm(result);
					return result;
				}

				if ((new_cur.left.left == null || new_cur.left.left.color == false) && (new_cur.left.right != null && new_cur.left.right.color == true)) {
					//@ fold tree_perm(new_cur.left.left);
					//@ Node new_cur_right_left = new_cur.left.right.left;
					//@ fold tree_perm(new_cur.left.right);
					//@ boolean new_cur_right_color = get_color(new_cur.left.right);
					//@ fold tree_perm(new_cur.left);
					new_cur.left = rotateLeft(new_cur.left) /*@ with { B = to_bag(new_cur.left); node_color = get_color(new_cur.left); right_node_color = new_cur_right_color; right_left_node = new_cur_right_left; rcase = 3; } @*/;
					//@ unfold tree_perm(new_cur.left);
					//@ unfold tree_perm(new_cur.left.left);
					//@ unfold tree_perm(new_cur.left.right);
				}

				if (new_cur.left.left != null && new_cur.left.left.color == true) {
					new_cur.left.left.color = false;

					//@ fold tree_perm(new_cur.left.left);
					//@ fold tree_perm(new_cur.left.right);
					//@ Node new_cur_left_right = new_cur.left.right;
					//@ fold tree_perm(new_cur.left);
					//@ boolean new_cur_left_color = get_color(new_cur.left);
					//@ fold tree_perm(new_cur);
					result.right = rotateRight(new_cur) /*@ with { B = to_bag(new_cur); node_color = get_color(new_cur); left_node_color = new_cur_left_color; left_right_node = new_cur_left_right; rcase = 4; } @*/;

					//@ fold tree_perm(result);
					return result;
				}

				//@ fold tree_perm(new_cur.left.left);
				//@ fold tree_perm(new_cur.left.right);
				//@ fold tree_perm(new_cur.left);
				//@ fold tree_perm(new_cur);
				//@ fold tree_perm(result);
				return result;
			}

			//@ unfold tree_perm(current.left.left);
			//@ unfold tree_perm(current.left.right);
			if (current.left.color == false && (current.left.left == null || current.left.left.color == false) && (current.left.right == null || current.left.right.color == false)) {
				current.left.color = true;
				if (current.color == true) {
					current.color = false;
				} else {
					current.dblack = true;
				}

				//@ fold tree_perm(current.left.left);
				//@ fold tree_perm(current.left.right);
				//@ fold tree_perm(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				return current;
			}

			if ((current.left.left == null || current.left.left.color == false) && (current.left.right != null && current.left.right.color == true)) {
				//@ fold tree_perm(current.left.left);
				//@ Node right_left = current.left.right.left;
				//@ fold tree_perm(current.left.right);
				//@ boolean right_color = get_color(current.left.right);
				//@ fold tree_perm(current.left);
				current.left = rotateLeft(current.left) /*@ with { B = to_bag(current.left); node_color = get_color(current.left); right_node_color = right_color; right_left_node = right_left; rcase = 3; } @*/;
				//@ unfold tree_perm(current.left);
				//@ unfold tree_perm(current.left.left);
				//@ unfold tree_perm(current.left.right);
			}

			if (current.left.left != null && current.left.left.color == true) {
				current.left.left.color = false;

				//@ fold tree_perm(current.left.left);
				//@ fold tree_perm(current.left.right);
				//@ Node left_right = current.left.right;
				//@ fold tree_perm(current.left);
				//@ boolean left_color = get_color(current.left);
				//@ fold tree_perm(current.right);
				//@ fold tree_perm(current);
				Node result = rotateRight(current) /*@ with { B = to_bag(current); node_color = get_color(current); left_node_color = left_color; left_right_node = left_right; rcase = 4; } @*/;
				return result;
			}

			//@ fold tree_perm(current.left.left);
			//@ fold tree_perm(current.left.right);
			//@ fold tree_perm(current.left);
		}

		//@ fold tree_perm(current.right);
		//@ fold tree_perm(current);
		return current;
	}

	//@ given bag<int> B;
	//@ given boolean old_color;
	//@ requires tree_perm(current) ** sorted(current) ** no_db_red(current);
	//@ requires B == to_bag(current);
	//@ requires old_color == get_color(current);
	//@ ensures current == null ==> \result == null ** tree_perm(current) ** sorted(current) ** no_db_red(current);
	//@ ensures current != null ==> \result != null ** tree_perm_except(current, \result) ** tree_perm(\result) ** valid(current, \result) ** sorted_except(current, \result) ** sorted(\result) ** no_db_red_except(current, \result) ** no_db_red(\result) ** larger(to_bag_except(current, \result), to_bag(\result)) ** \unfolding tree_perm(\result) \in \result.left == null;
	//@ ensures B == to_bag_except(current, \result) + to_bag(\result);
	//@ ensures current == \result ==> old_color == get_color(\result);
	//@ ensures current != \result ==> old_color == get_color(current, \result);
	Node getMin(Node current) {
		if (current == null) {
			return current;
		}

		//@ unfold tree_perm(current);
		//@ boolean current_color = current.color;
		if (current.left != null) {
			//@ boolean left_color = get_color(current.left);
			//@ bag<int> left_before = to_bag(current.left);
			Node result = getMin(current.left) /*@ with { B = left_before; old_color = get_color(current.left); } @*/;
			//@ bag<int> left_after = to_bag_except(current.left, result);
			//@ bag<int> result_content = to_bag(result);
			//@ assert subbag(left_after, left_before);
			//@ assert subbag(result_content, left_before);
			//@ prove_not_in_tree(current.right, result, to_bag(current.right), get_color(current.right));
			//@ fold tree_perm_except(current, result);
			return result;
		}

		//@ fold tree_perm(current);
		//@ fold tree_perm_except(current, current);
		return current;
	}

	//@ given bag<int> B;
	//@ given boolean old_color;
	//@ requires tree_perm(current) ** sorted(current) ** no_db_red(current);
	//@ requires B == to_bag(current);
	//@ requires old_color == get_color(current);
	//@ ensures current == null ==> \result == null;
	//@ ensures \result == null ==> tree_perm(current) ** sorted(current) ** no_db_red(current) ** B == to_bag(current);
	//@ ensures \result != null ==> tree_perm_except(current, \result) ** tree_perm(\result) ** valid(current, \result) ** sorted_except(current, \result) ** sorted(\result) ** no_db_red_except(current, \result) ** no_db_red(\result) ** B == to_bag_except(current, \result) + to_bag(\result);
	//@ ensures current == \result ==> old_color == get_color(\result);
	//@ ensures current != \result ==> old_color == get_color(current, \result);
	Node search(Node current, int key) {
		if (current == null) {
			return current;
		}

		//@ unfold tree_perm(current);
		if (key < current.key) {
			//@ bag<int> left_before = to_bag(current.left);
			Node result = search(current.left, key) /*@ with { B = to_bag(current.left); old_color = get_color(current.left); } @*/;
			/*@
				if (result != null) {
					bag<int> left_after = to_bag_except(current.left, result);
					bag<int> result_content = to_bag(result);
					assert subbag(left_after, left_before);
					assert subbag(result_content, left_before);
					prove_not_in_tree(current.right, result, to_bag(current.right), get_color(current.right));
					unfold tree_perm(result);
					assert current != result;
					fold tree_perm(result);
					fold tree_perm_except(current, result);
				} else {
					fold tree_perm(current);
				}
			@*/
			return result;
		}
		if (key > current.key) {
			//@ bag<int> right_before = to_bag(current.right);
			Node result = search(current.right, key) /*@ with { B = to_bag(current.right); old_color = get_color(current.right); } @*/;
			/*@
				if (result != null) {
					bag<int> right_after = to_bag_except(current.right, result);
					bag<int> result_content = to_bag(result);
					assert subbag(right_after, right_before);
					assert subbag(result_content, right_before);
					prove_not_in_tree(current.left, result, to_bag(current.left), get_color(current.left));
					unfold tree_perm(result);
					assert current != result;
					fold tree_perm(result);
					fold tree_perm_except(current, result);
				} else {
					fold tree_perm(current);
				}
			@*/
			return result;
		}

		//@ fold tree_perm(current);
		//@ fold tree_perm_except(current, current);
		return current;
	}


	//@ given bag<int> B;
	//@ given boolean node_color;
	//@ given boolean right_node_color;
	//@ given Node right_left_node;
	//@ given int rcase;
	//@ requires node != null ** tree_perm(node) ** sorted(node);
	//@ requires \unfolding tree_perm(node) \in (node.right != null);
	//@ requires B == to_bag(node);
	//@ requires node_color == get_color(node);
	//@ requires right_node_color == \unfolding tree_perm(node) \in (get_color(node.right));
	//@ requires right_left_node == \unfolding tree_perm(node) \in (\unfolding tree_perm(node.right) \in (node.right.left));
	//@ requires rcase == 1 ==> node_color && right_node_color && db_red_at_top(node);
	//@ requires rcase == 2 ==> \unfolding tree_perm(node) \in (!node.color && !get_color(node.left) && get_color(node.right) && no_db_red(node.left) && db_red_at_top(node.right) && \unfolding tree_perm(node.right) \in (get_color(node.right.right)));
	//@ requires rcase == 3 ==> no_db_red(node) && \unfolding tree_perm(node) \in (!node.color && !get_color(node.left));
	//@ requires rcase == 4 ==> no_db_red(node) && \unfolding tree_perm(node) \in (!get_color(node.right) && \unfolding tree_perm(node.right) \in (!get_color(node.right.right)));
	//@ ensures \result != null ** tree_perm(\result) ** sorted(\result);
	//@ ensures \unfolding tree_perm(\result) \in (\result.left != null);
	//@ ensures B == to_bag(\result);
	//@ ensures node_color == get_color(\result);
	//@ ensures right_node_color == \unfolding tree_perm(\result) \in (get_color(\result.left));
	//@ ensures right_left_node == \unfolding tree_perm(\result) \in (\unfolding tree_perm(\result.left) \in (\result.left.right));
	//@ ensures rcase == 1 ==> db_red_at_top(\result);
	//@ ensures rcase == 2 ==> no_db_red(\result);
	//@ ensures rcase == 3 ==> no_db_red(\result);
	//@ ensures rcase == 4 ==> no_db_red(\result);
	Node rotateLeft(Node node) {
		//@ unfold tree_perm(node);
		Node tempNode = node.right;
		boolean tempColor = node.color;

		//@ bag<int> temp_content = to_bag(tempNode);
		//@ unfold tree_perm(tempNode);
		//@ bag<int> temp_left_content = to_bag(tempNode.left);
		//@ assert subbag(temp_left_content, temp_content);
		//@ assert (tempNode.key \memberof temp_content) != 0;
		node.right = tempNode.left;
		tempNode.left = node;

		node.color = tempNode.color;
		tempNode.color = tempColor;
		//@ fold tree_perm(node);
		//@ fold tree_perm(tempNode);
		return tempNode;
	}

	//@ given bag<int> B;
	//@ given boolean node_color;
	//@ given boolean left_node_color;
	//@ given Node left_right_node;
	//@ given int rcase;
	//@ requires node != null ** tree_perm(node) ** sorted(node);
	//@ requires \unfolding tree_perm(node) \in (node.left != null);
	//@ requires B == to_bag(node);
	//@ requires node_color == get_color(node);
	//@ requires left_node_color == \unfolding tree_perm(node) \in (get_color(node.left));
	//@ requires left_right_node == \unfolding tree_perm(node) \in (\unfolding tree_perm(node.left) \in (node.left.right));
	//@ requires rcase == 1 ==> node_color && left_node_color && db_red_at_top(node);
	//@ requires rcase == 2 ==> \unfolding tree_perm(node) \in (!node.color && get_color(node.left) && !get_color(node.right) && db_red_at_top(node.left) && no_db_red(node.right) && \unfolding tree_perm(node.left) \in (get_color(node.left.left)));
	//@ requires rcase == 3 ==> no_db_red(node) && \unfolding tree_perm(node) \in (!node.color && !get_color(node.right));
	//@ requires rcase == 4 ==> no_db_red(node) && \unfolding tree_perm(node) \in (!get_color(node.left) && \unfolding tree_perm(node.left) \in (!get_color(node.left.left)));
	//@ ensures \result != null ** tree_perm(\result) ** sorted(\result);
	//@ ensures \unfolding tree_perm(\result) \in (\result.right != null);
	//@ ensures B == to_bag(\result);
	//@ ensures node_color == get_color(\result);
	//@ ensures left_node_color == \unfolding tree_perm(\result) \in (get_color(\result.right));
	//@ ensures left_right_node == \unfolding tree_perm(\result) \in (\unfolding tree_perm(\result.right) \in (\result.right.left));
	//@ ensures rcase == 1 ==> db_red_at_top(\result);
	//@ ensures rcase == 2 ==> no_db_red(\result);
	//@ ensures rcase == 3 ==> no_db_red(\result);
	//@ ensures rcase == 4 ==> no_db_red(\result);
	Node rotateRight(Node node) {
		//@ unfold tree_perm(node);
		Node tempNode = node.left;
		boolean tempColor = node.color;

		//@ bag<int> temp_content = to_bag(tempNode);
		//@ unfold tree_perm(tempNode);
		//@ bag<int> temp_right_content = to_bag(tempNode.right);
		//@ assert subbag(temp_right_content, temp_content);
		//@ assert (tempNode.key \memberof temp_content) != 0;
		node.left = tempNode.right;
		tempNode.right = node;

		node.color = tempNode.color;
		tempNode.color = tempColor;
		//@ fold tree_perm(node);
		//@ fold tree_perm(tempNode);
		return tempNode;
	}
}
